#include <stdio.h>
#include "CBar.h"

void CBar::setfs()
{
  box(FL_DOWN_FRAME);
  color(FL_WHITE);
  selection_color(FL_DARK3);
  align(FL_ALIGN_LEFT);
  int * sizep;
  int n = Fl::get_font_sizes(FL_HELVETICA,sizep);
  if (n == 0)
    {
      fs = 0;
    }
  else if (sizep[0] == 0 && n <= 1)
    {
      fs = (8*h()+5)/10;
    }
  else
    {
      int i;
      for (i = 1; i < n; i++)
	{
	  if (sizep[i] >= h()) break;
	}
      fs = sizep[i-1];
    }
   
}

void CBar::draw()
{
  unsigned int bs;
  char  lbl[5];


  bs = (val*w()+50)/100;

  fl_color(selection_color());
  fl_rectf(x(),y(),bs,h());
  fl_color(color());
  fl_rectf(x() + bs,y(),w() - bs,h());

  fl_font(FL_HELVETICA,fs);
  sprintf(lbl,"%3d%%",val);
  fl_color(labelcolor());
  fl_draw(lbl,x(),y(),w(),h(),FL_ALIGN_CENTER);

  draw_box();
  draw_label();
}

bool CBar::value(unsigned char _v)
{
  if (_v != val)
    {
      val = _v;
      if (val > 100) val = 100;
      this->redraw();
      return true;
    }
  else
    return false;
}
