#ifndef __CExpander_h
#define __CExpander_h

#include "my_list.h"

class Bkmk
{
  char* m_name;
  unsigned int m_position;
 public:
  Bkmk() : m_name(NULL), m_position(0) {};
  Bkmk(char* _nm, unsigned int _p) : m_position(_p)
    {
      int len = strlen(_nm)+1;
      m_name = new char[len];
      for (int i = 0; i < len; i++) m_name[i] = _nm[i];
    }
  Bkmk(const Bkmk& rhs) : m_name(NULL)
    {
      *this = rhs;
    }
  ~Bkmk() { if (m_name != NULL) delete [] m_name; }
  unsigned int value() { return m_position; }
  char *name() { return m_name; }
  bool operator<(const Bkmk& rhs) { return (m_position < rhs.m_position); }
  Bkmk& operator=(const Bkmk& rhs)
  {
    if (m_name != NULL) delete [] m_name;
    if (rhs.m_name != NULL)
      {
	int len = strlen(rhs.m_name)+1;
	m_name = new char[len];
	for (int i = 0; i < len; i++) m_name[i] = rhs.m_name[i];
      }
    else
      m_name = NULL;
    m_position = rhs.m_position;
    return *this;
  }
  bool operator==(const Bkmk& rhs)
  {
    return (m_position == rhs.m_position && strcmp(m_name,rhs.m_name) == 0);
  }
};

class CCharacterSource
{
 public:
  virtual int getch() = 0;
};

class CExpander : public CCharacterSource
{
public:
  CExpander() {};
  virtual ~CExpander() {};
  virtual int openfile(char *src) = 0;
  virtual unsigned int locate() = 0;
  virtual void locate(unsigned int n) = 0;
  virtual bool hasrandomaccess() = 0;
  virtual void sizes(unsigned long& file, unsigned long& text) = 0;
  virtual CList<Bkmk>* getbkmklist() { return NULL; }
};
#endif
